-- Modified canvas functions
-- version 2012.10.28
gr	= love.graphics
local Canvas = {}
Canvas.__index = Canvas

function newCanvas( v1, v2 )
	if type(v1) == 'string' then v1 = gr.newImage(v1) end
	if type(v1) == 'userdata' then
		canvas = gr.newCanvas( v1:getWidth(), v1:getHeight() )
		gr.setCanvas( canvas )
		gr.setColor( 255, 255, 255, 255 )
		gr.draw( v1 )
		gr.setCanvas()
		else
		canvas = gr.newCanvas( v1, v2 )
		gr.setCanvas( canvas )
		gr.setCanvas()
		end

	local tab = { canvas = canvas }
	setmetatable( tab, Canvas )
	return tab
	end

function Canvas:line( ... )
	local vert = {...}
	if type(vert[1]) == 'table' then vert=vert[1] end
	gr.setCanvas( self.canvas )
	for i = 1, #vert - 2, 2 do
		gr.line( vert[i], vert[i+1], vert[i+2], vert[i+3] )
		end
	gr.setCanvas( )
	end

function Canvas:box( ... )
	gr.setCanvas( self.canvas )
	gr.rectangle( ... )
	gr.setCanvas( )
	end

function Canvas:circle( ... )
	gr.setCanvas( self.canvas )
	gr.circle( ... )
	gr.setCanvas()
	end

function Canvas:arc( ... )
	gr.setCanvas( self.canvas )
	gr.arc( ... )
	gr.setCanvas()
	end

function Canvas:text( ... )
	gr.setCanvas( self.canvas )
	gr.print( ... )
	gr.setCanvas()
	end

function Canvas:point( x, y )
	gr.setCanvas( self.canvas )
	gr.point( x + 0.5, y + 0.5 )
	gr.point( x + 0.5, y - 0.5 )
	gr.point( x - 0.5, y - 0.5 )
	gr.point( x - 0.5, y + 0.5 )
	gr.setCanvas()
	end

function Canvas:polygon( ... )
	gr.setCanvas( self.canvas )
	gr.polygon( ... )
	gr.setCanvas()
	end

function Canvas:triangle( ... )
	gr.setCanvas( self.canvas )
	gr.triangle( ... )
	gr.setCanvas()
	end

function Canvas:trianglestrip( mode, tab )
	for i = 1, #tab-2 do
		gr.setCanvas( self.canvas )
		gr.triangle( mode, tab[i][1],tab[i][2],tab[i+1][1],tab[i+1][2],tab[i+2][1],tab[i+2][2])
		gr.setCanvas( )
		end
	end

function Canvas:BackgroundColor( ... )
	local color = { gr.getColor( ) }
	gr.setCanvas( self.canvas )
	gr.setColor( ... )
	gr.rectangle('fill',0,0,self.canvas:getWidth(),self.canvas:getHeight())
	gr.setCanvas()
	gr.setColor( color )
	end

function Canvas:Color( ... )
	gr.setColor( ... )
	end

function Canvas:draw( ... )
	arg = { ... }
	if type( arg[1] ) == 'userdata' then
			gr.setCanvas( self.canvas )
			gr.setColor( 255, 255, 255, 255 )
			gr.draw( ... )
			gr.setCanvas( )
		else
		gr.draw(self.canvas, ...)
		end
	end

function Canvas:fontsize( num )
	gr.setFont( gr.newFont( num ) )
	end

return Canvas
