-- main.lua for mod_canvas.love
require 'Canvas'
require 'effect'
function love.load()
	gr, li, pi	= love.graphics, love.image, math.pi
	gr.setCaption( 'Uses Modified Canvases' )
	off, ang	= 0, 0
	gr.setBackgroundColor( 255, 255, 255, 0 )	-- zero alpha for image background
    screen	= {
		w	= gr.getWidth(),
        h	= gr.getHeight()
		}
	image	= gr.newImage( 'Love.jpg' )	-- background image
	imageb	= gr.newImage( 'buda.png' )
	create_canvases()					-- create all the canvases needed
	end

function create_canvases()
	can0 = newCanvas( image )
	can1 = newCanvas( 250, 250 )		-- creates blank canvas and draws on it
		can1:Color(  255, 55, 185, 255  )
			can1:circle( 'fill', 125, 125, 125 )
		can1:Color( 255, 255, 255, 255  )
			can1:circle( 'fill', 80, 80, 60 )
		can1:Color(  185, 185, 185, 255  )
			can1:circle( 'line', 80, 80, 60)

	can2 = newCanvas( imageb )
		can2:Color(  255,  0,  0, 255  )
			can2:circle('line', 45, 45, 20 )
		can2:Color(  255, 255, 255, 255  )
			can2:fontsize( 16 )
			can2:text( 'message', 5, 75 )
			can2:box( 'fill', 35, 35, 20, 20 )
			can2:triangle('line',0,89,45,0,89,89)
		can2:Color(   0,   0,   0, 255 )
			can2:text( '2', 40, 35 )

	can3 = newCanvas( imageb )
		can3:Color( 255, 255,   0, 255 )
			can3:box( 'fill', 35, 35, 20, 20 )
		can3:Color(  0,   0,  0, 255 )
			can3:text( '3',    40, 35 )
		can3:Color(  0, 255,  0, 255 )
			can3:line(  0, 0,   90, 90 )
			can3:line( 90, 0,    0, 90 )
		can3:Color(255,0,0,255)
			strip={{10,85},{10,65},{30,85},{30,65},{50,85},{50,65},{70,85},{70,65}}
			can3:trianglestrip( 'line', strip )

	can4 = newCanvas( imageb )				-- demonstrates canvas from preloaded image data
			can4:Color( 255, 255,   0, 255 )
				can4:line( 0, 0, imageb:getWidth(), imageb:getHeight() )
				can4:line( 0, imageb:getHeight(), imageb:getWidth(), 0 )
				can4:box( 'line', 0, 0, imageb:getWidth(), imageb:getHeight() )
			can4:Color(   0, 255,   0, 255 )
				can4:circle( 'line', 45, 45, 20 )
				can4:arc( 'fill', 60, 60, 20, 0, pi/2 )
			can4:Color(   0,   0, 255, 255 )
				can4:box( 'fill', 35, 35, 20, 20 )
			can4:Color( 255, 255, 255, 255 )
				can4:text( '4', 40, 35, 0 )
				can4:polygon( 'line', 10, 80, 45, 10, 80, 80 )

	can5 = newCanvas( 100, 100 )			-- demonstrates canvas from width & height
		can5:BackgroundColor( {255, 0, 0, 255} )
		can5:Color( {255, 255, 255, 255} )
			can5:box('line',1,1,98,98)
		can5:Color(   0, 255,   0, 255 )
			can5:circle( 'fill', 50, 50, 50 )
		can5:Color(   0,   0,   0, 255 )
			can5:circle( 'line', 50, 50, 49 )
			can5:draw( imageb, 50, 50, 0, 1, 1, imageb:getWidth()/2,imageb:getHeight()/2)
		can5:Color(   0, 255, 255, 255 )
			can5:box( 'fill', 35, 35, 20, 20 )
		can5:Color(   0,   0,   0, 255 )
			can5:text( '5', 40, 35 )
		can5:Color(255,255,255,255)
			for j=5,15 do for i=5,15 do can5:point( i, j ) end end
			can5:Color(255,255,0,255)
		can5:line(10,10,15,10,15,20,10,20,10,30,15,30,15,40,10,40,10,50,15,50,15,60,10,60,10,70,15,70,15,80,10,80,10,90,15,90)

	can6 = newCanvas( 'buda.png')			-- demonstrates canvas from filenaame
		can6:Color( 255,   0, 255, 255 )
			can6:box( 'fill', 35, 35, 20, 20 )
		can6:Color(   0,   0,   0, 255 )
			can6:text( '6', 40, 35 )

	end

function love.draw()

	can0:draw( )				-- add background image
can6:draw(700,450)
	gr.setPixelEffect( effect )	-- gradient effect applied
		can1:draw( screen.w/2+off, screen.h/2+off, ang )
		gr.setPixelEffect()
	can2:draw(screen.w/2+off, screen.h/2+off, -ang, 1,1,-90,-90 )
	can3:draw( 100, 100, ang, 1, 1, can3.canvas:getWidth()/2, can3.canvas:getHeight()/2)
	can4:draw( 100, 500,-ang, 1, 1, can4.canvas:getWidth()/2, can4.canvas:getHeight()/2)
	can5:draw( 700, 100, ang/4,1,1,can5.canvas:getWidth()/2,can5.canvas:getHeight()/2)
	gr.setColor( 255, 255, 255, 255 )
	gr.print( 'fps: '..love.timer.getFPS( ), screen.w-95, screen.h-20 )
	end

function love.update( dt ) ang	= ang + dt end

function love.keypressed( key )
	if key	== 'escape' then love.event.push( 'quit' )	end
	end

